#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdlib.h>
#include <iostream.h>
#include <vector>

#define TAMANO_LINEA 256
	
int main(int argc, char * argv[]) 
{
	FILE * fd;//descriptor de archivo, para abrir archivo entregado como parametro
	
	float **matrix;//matriz de tamao variable
	float *key,*minimo;//arreglo dinamico de pesos y arreglo dinamico para encontrar el minimo
	int *p,*Q;//arreglo dinamico de padres y "cola de prioridad"
	char *dato;//puntero a caracter para lectura del archivo entregado como parametro

	int size,u,vertice1,vertice2,indice;
	float weight,min;//para almacenar el peso del arco y para calculo del minimo	
	char linea[TAMANO_LINEA];//almacena cada linea del archivo entregado por consola
	char flag;

	int cuenta=0;
	int vmax=0;
	int suma=0;
	float sumapeso=0;//para entregar peso total del arbol de expansion minima
	
	vector<int> nodo1;//vector que guarda nodo 1 de un arco (para llenar matriz)
	vector<int> nodo2;//vector que guarda nodo 2 de un arco (para llenar matriz)
	vector<float> peso;//vector que guarda el peso de un arco (para llenar matriz)

	fd=stdin;

	if (argc!=2)//error en los parametros de entrada
	{
		cout<<"\nError...\nuso: conectividad <nombre_archivo_entrada>.\n"<<endl;
		exit(1);
	}

	else if ((fd=fopen(argv[1],"r"))==NULL)//error al abrir archivo que contiene el grafo 
	{
		cout<<"error, el archivo "<<argv[1]<<" no se pudo abrir, compruebe que existe...\n"<<endl; 
		exit(1);
	}

	system("clear");//limpio pantalla

	cout<<"Analizando arbol de expansion minima en grafo contenido en archivo: "<<argv[1]<<"....\n"<<endl;

    while(fgets(linea, TAMANO_LINEA, fd)!=NULL)//ciclo para leer archivo de entrada y crear matriz de pesos
	{
		vertice1=atoi(strtok(linea," \t\n"));//obtengo el valor del nodo inicial
		nodo1.push_back(vertice1);//ingreso el nodo de inicio al vector de nodos de origen
		
		if(vertice1>vmax)
			vmax=vertice1;//para el calculo del total de nodos del grafo (numero de nodos=1+vmax)

		vertice2=atoi(strtok(NULL," \t\n"));//obtengo el valor del nodo final
		nodo2.push_back(vertice2);//ingreso el nodo de inicio al vector de nodos de final
      	
		if(vertice2>vmax)
			vmax=vertice2;//para el calculo del total de nodos del grafo (numero de nodos=1+vmax)

		while((dato=strtok(NULL," \t\n")) != NULL)//leo el peso del arco
		{
			weight=atof(dato);//almaceno el peso en una variable del tipo flotante
		}

		peso.push_back(weight);//ingreso el peso del arco al vector de pesos (para crear la matriz de pesos)
		cout<<"Arco: "<<vertice1<<" - "<<vertice2<<", peso: "<<weight<<endl;	
	}

	size=vmax+1;//guardo el tamao del grafo
	cout<<"\nEl tamao del grafo es: "<<size<<endl;

	matrix=(float **)malloc((size)*sizeof(float));//creo matriz de tamao variable para matriz de pesos
	for(int i=0;i<size;i++)
		matrix[i]=(float*)malloc((size)*sizeof(float));

	for(int i=0; i<size; i++)//inicializo la matriz con ceros
		for(int j=0; j<size; j++)
			matrix[i][j]=0;
	
	for(int i=0; i<nodo1.size(); i++)
		matrix[nodo2[i]][nodo1[i]]=peso[i];//ingreso los pesos respectivos de cada arco [nodo1-nodo2] a la matriz de pesos 

	cout<<"\nMatriz de pesos: (indica el peso del arco i-j)\n"<<endl;//muestro por pantalla la matriz de adyacencia

	cout<<"i\\j\t";//muestro la matriz por pantalla
	for(int i=0;i<size;i++)
		cout<<i<<"\t";
	cout<<endl;

	for(int j=0;j<size;j++)
	{
		cout<<j<<"\t";
		for(int i=0;i<size;i++)
		{
			cout<<matrix[i][j]<<"\t";
		}
		cout<<endl;
	}
	cout<<endl;//se pregunta si se desea ver la solucion final o paso a paso (si la respuesta es s, se vera el algoritmo en detalle)
	cout<<"Desea ver el algoritmo paso a paso? (si ingresa [n] se mostrar solo el resultado final...) s/n: ";
	cin>>flag;//se almacena la respuesta del usuario en la variable char flag
	
	while((flag!='s')&&(flag!='n'))//para evitar que se ingresen valores distintos a "s"  "n"
	{
		cout<<"Error al ingresar opcion, ingrese s/n: ";
		cin>>flag;
	}
	cout<<endl;
	system("clear");//limpio pantalla
////////////////////////////////Algoritmo de Prim//////////////////////////////////////////

	minimo=(float *)malloc((size)*sizeof(float));//solicito memoria para arreglos de tamao variable
	Q=(int *)malloc((size)*sizeof(int));	
	key=(float *)malloc((size)*sizeof(float));
	p=(int *)malloc((size)*sizeof(int));

	for(int i=0;i<size;i++)
		Q[i]=1;//ingreso todos los vertices a la cola de prioridad (un 1 en la posicion i, sugnifica que el nodo i aun esta en la cola de prioridad, un 0 significa que ya fue ingresado a la solucion

	for(int i=1;i<size;i++)
	{
		key[i]=9999;//inicializo el arreglo de pesos con valor "infinito"
		minimo[i]=9999;//arreglo minimo es igual a key, solo sirve para encontrar el peso minimo actual
	}

	key[0]=0;//empiezo del nodo 0, raiz del arbol
	minimo[0]=0;//minimo=key para enconrar el minimo hasta la fecha
	p[0]=-1;//padre de la raiz es nulo
	
	for(int i=0;i<size;i++)
		suma=suma+Q[i];//esta suma sirve para verificar si aun hay elementos en la cola de prioridad, si la suma es 0, no existen elementos y la cola esta vacia, si la suma es distinta de cero, indica el numero de nodos aun presentes en la cola de prioridad

	while(suma!=0)//mientras la cola no este vacia
	{
		min=1000;//tomo el valor minimo como un valor alto
		
		if(flag=='s')//el usuario pidio ver el algoritmo paso a paso
			cout<<"Arreglo de Pesos (valor infinito representado con 9999): ";

		for(int i=0;i<size;i++)
		{
			if(min>minimo[i])//calcula el minimo actual (que no ha sido ingresado a la solucin)
			{
				min=minimo[i];//guarda el minimo y su posicion
				indice=i;
			}
			
			if(flag=='s')//el usuario pidio ver el algoritmo paso a paso
			{
				cout<<key[i]<<", ";
			}
		}

		if(flag=='s')//el usuario pidio ver el algoritmo paso a paso
			cout<<"\n"<<endl;

		minimo[indice]=9999;//sobreescribe el minimo de manera de buscar el minimo que le sigue a este en el siguiente ciclo del while

		if(flag=='s')//el usuario pidio ver el algoritmo paso a paso
			cout<<"Minimo peso que no ha sido ingresado a la solucin: "<<min<<endl;
					
		for(int i=0;i<size;i++)
		{
			if((Q[i]==1)&&(key[i]<=min))//si el nodo esta en la cola de prioridad y su peso es menor que el minimo, se extrae ese nodo (se ingresa a la solucin)
			{
				u=i;
				Q[u]=0;//elimino el nodo de la cola de prioridad
			}
		}
		
		if(flag=='s')//el usuario pidio ver el algoritmo paso a paso
			cout<<"Nodo ingresado a la solucin: "<<u<<endl;

		for(int j=0;j<size;j++)
		{
			if(matrix[j][u]!=0)//solo para los arcos adyacentes del nodo extraido (los que tienen un peso distinto de 0)
			{
				if ((Q[j]==1)&&(matrix[j][u]<key[j]))
				{
					p[j]=u;//actualizo el padre de los nodos
					
					if(flag=='s')//el usuario pidio ver el algoritmo paso a paso
						cout<<"Nodo "<<j<<" adyacente con nodo "<<u<<", peso arco: "<<matrix[j][u]<<endl;

					key[j]=matrix[j][u];//actualizo los pesos de sus arcos
					minimo[j]=key[j];//para el calculo del nuevo minimo
				}
			}
		}

		suma=0;//reinicializo la suma
		for(int i=0;i<size;i++)
			suma=suma+Q[i];//calculo nueva suma para ver cuantos nodos aun quedan en la cola de prioridad
		
		if(flag=='s')//el usuario pidio ver el algoritmo paso a paso 
		{
			cout<<"\nArreglo de pesos actualizado: ";
			for(int i=0;i<size;i++)
				cout<<key[i]<<", ";
			cout<<"\n"<<endl;

			if(suma==0)
			{
				cout<<"Algoritmo finalizado, presione <Enter> para ver resultado final"<<endl;
				getchar();
			}

			else
			{
				cout<<"Falta(n) "<<suma<<" Nodo(s) por procesar...\n"<<endl;
				cout<<"Presione <Enter> para ver el siguiente paso"<<endl;
				getchar();
			}
		}
	}

	for(int i=0;i<size;i++)//calculo el peso total del arbol de expansion minima
		sumapeso=sumapeso+key[i];

	system("clear");//limpio pantalla para desplegar resultado final
	cout<<"Costo total del arbol de expansion minima: "<<sumapeso<<"\n"<<endl;

	cout<<"Solucin compuesta por los arcos:\n"<<endl;

	for(int i=1;i<size;i++)
		cout<<p[i]<<" - "<<i<<", con peso: "<<key[i]<<endl;
	cout<<endl;
	cout<<"Nodo 0 tomado como nodo raiz del rbol de expansin mnima.\n"<<endl;

	free(minimo);//libero memoria solicitada
	free(Q);//libero memoria solicitada
	free(key);//libero memoria solicitada
	free(p);//libero memoria solicitada
}
//////////////////////////Fin Algoritmo de Prim/////////////////////////////////////////////////////

